#!/usr/bin/perl

##Array

#Definizione e inizializzazione di un array
@musica = ("violino", "flauto", "oboe");

#Esempio di accesso alle locazioni dell'array
#Ricordarsi che, come in java, anche con perl
#gli array sono base zero
print "secondo elemento dell'array: ".$musica[1]."\n";

#Esempio di inserimento di un elementonell'array
push(@musica, "chitarra");

#Esempio di eliminazione del primo elemento dell'array
print "pop su un elemento dell'array: ".pop(@musica)."\n";

#Ottenere la dimensione dell'array
$dimensione = @musica;

#Indice dell'ultimo elemento presente nell'Array
#Confrontandolo con il valore precedente si comprende
#bene che gli array sono base zero
$array_string = "@musica";

print $array_string." con dimensione ".$dimensione."\n";

print "indice dell'ultimo elemento: ".$#musica."\n";

#doppia inizializzazione, nelle variabili $a e $b vengono
#memorizzati i valori dei primi due elementi dell'array
($a, $b) = @musica;

print "variabili a e b: ".$a." ".$b."\n";

#La variabile $violino verr inizializzata con il valore
#del primo elemento dell'array, mentre i restanti elementi
#verranno memorizzati nel vettore @altri_strumenti
($violino, @altri_strumenti) = @musica;


#Array associativi (coppia chiave valore)

#definizione di un array associativo.
#il primo valore  la chiave, mentre il secondo
#rappresenta il valore
%cartoni = (	"Paperino", 39,
		"Paperone", 34,
		"Sirenetta", "3 anni pesce",
		"Lupo Alberto", 21,
		"Archimede Pitagorico", 108);

#Esempio di accesso ai valori del vettore associativo
print Paperino." ".$cartoni{"Paperino"}."\n";
print paperino." ".$cartoni{"paperino"}."\n";
print Sirenetta." ".$cartoni{"Sirenetta"}."\n";
print Archimede." ".$cartoni{"Archimede"}."\n";
print "Lupo Alberto"." ".$cartoni{"Lupo Alberto"}."\n";


#Esempio di assegnazione di un array associativo a 
#un normale vettore 
@array_cartoni = %cartoni;
#Per comprendere il risultato di questa assegnazione
# necessario stampare i valori del vettore @array_cartoni
print "contenuto del vettore: "."@array_cartoni"."\n";
print "Accesso a una coppia di valori del nuvo vettore: ".$array_cartoni[2]." ".$array_cartoni[3]."\n";


#creazione di un array associativo partendo da un array normale
#E' una operazione possibile ma  necessario essere coscienti
#di ci che si ottiene facendola
%assoc_caroni = @array_cartoni;

#Accesso lineare di vettori associativi
#La funzione keys ritorna una lista di tutte le chiavi 
#(indici simbolici) dell'array associativo
foreach $cartone_animato (keys %cartoni)
   {
      print "Conosco l'et di $cartone_animato:"." ".$cartoni{$cartone_animato}."\n";
   }

#values restituisce la lista di tutti i valori 
#memorizzati nell'array associativo specificato
foreach $anni (values %cartoni)
   {
      print "Qualcuno ha $anni anni\n";
   }

#in un contesto calare, sia keys che values 
#restituiscono il numero di chiavi/elementi presnti
print "Sono presenti ".keys(%cartoni)." cartoni nel nostro array associativo"."\n";
print "Sono presenti ".values(%cartoni)." cartoni nel nostro array associativo"."\n";


#Metodi di accesso semplificato ai campi di un vettore associativo
$max = 0;
$Nome = "";
while (($cartone, $anni) = each(%cartoni))
{
   print "Il cartone $cartone ha $anni anni\n";
   
   if ( $anni > $max ){
   	$max = $anni;
   	$Nome = $cartone;
   }
}

print "Nome ed et del pi vecchio\n"." Nome: ".$Nome."\n Eta: ".$max."\n";


$nome_file = "paperduck.txt";
open(handler, $nome_file);

@file_array = <handler>;
foreach $riga (@file_array){
	print "Riga del file = ".$riga."\n";	
}

#Eliminazione del finelinea dalle linee del file
chomp(@file_array);
for ($i = 0; $i < @file_array; $i++) {
	print "Riga del file numero ".$i." = ".$file_array[$i]."\n";
}

# Apre in lettura
open(INFO, $file);
# Apre in scrittura
open(INFO, ">$file");
# Apre per appendere l'uscita
open(INFO, ">>$file");
# Altro modo per aprire in lettura
open(INFO, "<$file");


close(handler);